
' *** CatPatch Part TWO... This must be '$INCLUDE:' at the end of your prg
' This logic (C) 1987 Michael Cleverly - All Rights Reserved.
' Adapted and massivly overhauled from logic written for the RBBS system





In.put:                                                ' Input ARG$
     NORET=1:GOSUB OUT.PUT
     ARG$ = ""
     NOFSX$ = ""
     P.LINE=0
     LOG.OFF$ = "4"
     ENDTIME = FNTI! + (VAL(LOG.OFF$)*60)

In.put1:                                               ' Idle user check
     IF FNTI! > ENDTIME AND L.OCAL <> 1 THEN
         X.LN$ = "NO INPUT IN " + _
                   LOG.OFF$ + _
                   " MINUTES! YOU ARE LOGGED OFF! BYE!"
         GOSUB X.lnprint
         GOTO Fast.exit
     END IF

In.put2:                                       'IN.PUT2 is one of two
     IF ZX$ = "" THEN _                        'stack command routines
        GOTO In.put3                           'IN.RET is the
other:
     A$ = LEFT$(ZX$,1)
     IF LEN(ZX$) < 1 THEN
        ZX$ = ""
        GOTO In.put3
     END IF
     ZX$ = RIGHT$(ZX$,LEN(ZX$)-1)
     GOTO In.put4

In.put3:
     GOSUB Car.test
     A$ = INKEY$

In.put4:
     IF A$ <> "" THEN _
        GOTO In.put5
     IF L.OCAL <> 1 THEN _
        IF NOT(EOF(3)) THEN _
           A$ = INPUT$(1,3)

In.put5:
     IF A$ = CR$ THEN
        NORET = 0
        LN$ = ""
        GOSUB Out.put
        GOTO In.ret
     END IF
     IF A$ = CHR$(8) OR A$ = CHR$(7) THEN _
        GOTO In.put8
     IF A$ < CHR$(32) THEN _
        GOTO In.put1
     PRINT A$;

In.put6:
     IF L.OCAL = 1 THEN _
        GOTO In.put7
     PRINT #3,A$;

In.put7:
     IF LEN(ARG$) > 254 THEN _
        GOTO In.put1
     ARG$ = ARG$ + A$
     LN$ = A$
     NORET = 1
     GOSUB Car.test
     GOTO In.put1

In.put8:                                       ' Backspace
     IF LEN(ARG$) = 0 THEN _
        GOTO In.put1
     ARG$ = LEFT$(ARG$,LEN(ARG$)-1)
     PRINT BK.ARW$;
     IF L.OCAL = 1 THEN _
        GOTO In.put1
     PRINT #3, BACK.SP$;
     GOTO In.put1

In.ret:                                        'other stack command routine
     ZB = INSTR(ARG$,";")
     IF ZB = 0 THEN
        GOTO In.ret1
      ELSE ZX$ = ZX$ + MID$(ARG$,ZB + 1)
        ARG$ = LEFT$(ARG$,ZB - 1)
        WHILE INSTR(ZX$,";") <> 0
          MID$(ZX$,INSTR(ZX$,";"),1) = CHR$(13)
        WEND
        ZX$ = ZX$ + CHR$(13)
     END IF
In.ret1:
     IF UPLOW = 1 THEN _
        GOSUB Uplow
     NORET = 0
     LN$="":OUT$=""
     RETURN

Out.put:         '** Print LN$: If NORET=1 then print without carriage return
     IF NORET = 1 THEN
        NORET = 0
        GOTO Out.put1
     END IF
     GOTO Out.put3

Out.put1:                                      '** PRINT LN$ W/O C/R
     PRINT LN$;

Out.put2:
     IF L.OCAL = 1 THEN _
        GOTO Chk.line1
     PRINT #3,OUT$;
     out$=""
     PRINT #3,LN$;
     GOSUB Car.test
     GOTO Chk.line1

Out.put3:                                      '** PRINT LN$ W/ C/R
     PRINT LN$

Out.put4:
     IF L.OCAL = 1 THEN _
        GOTO Chk.line1
     PRINT #3,OUT$;
     out$=""
     PRINT #3,LN$
     IF LFEED = 1 THEN _
        PRINT #3,LF$;
     GOSUB Car.test

Chk.line1:
	P.LINE=P.LINE+1
	IF P.LINE=23 THEN GOSUB lin.cntr

Chk.line2:
     GOSUB Check.time2
     GOSUB Check.time1
     LN$="":NORET = 0:UPLOW=0
     RETURN

Lin.cntr:
	LN$=" [Enter] to continue..."
	noret=1
	gosub out.put
	gosub in.put
	p.line=0
	return

Car.test:                                      '** Check carrier drop
     IF L.OCAL = 1 THEN _
        RETURN
     IF INP(MSR) => 128 THEN _
        RETURN
	PRINT "The user dropped CARRIER! Tsk Tsk Tsk....--Returning to WildCat!"
     GOTO Car.drop

Car.drop:
     CLOSE
     GOTO FAST.EXIT

Fast.exit:                                     '** Close and return to system
     CLOSE
     OUT MCR,INP(MCR) OR 1
     SYSTEM

Exit.door:
     LN$="Closing door,":gosub magenta:LN$=" returning to ":gosub white:ln$=+BBS.NAME$:gosub cyan:ln$="...Please wait."
     GOSUB GREEN
     GOSUB OUT.PUT
     GOTO FAST.EXIT
Err.routine:                                   '** Error routine
     IF ERR = 57 THEN _                        'Tolerate lousy communications
        RESUME
          IF ERL = 64005 AND ERR = 5 THEN _
        RESUME NEXT
     IF ERL = 64002 AND ERR = 53 THEN
        RESUME Indoor.end
     END IF

      IF (ERR = 5 OR ERR = 6 OR ERR = 13 OR ERR = 15) THEN _
        RESUME

     IF ERR = 75 THEN
        LN$ = "FILE ACCESS ERROR - STOPPING " + DOOR.NAME$
        GOSUB Out.put
        RESUME Exit.door
     END IF

Write.err:
     CLOSE 4
     LN$ = "Error >" + _
           STR$(ERR) + _
           " Line >" + _
           STR$(ERL) + _
           " In file >" + _
           DOOR.NAME$ + _
           " on date >" + _
           DATE$ + _
           " " + _
           TIME$
     GOSUB Out.put
     OPEN "CATPATCH.ERR" FOR APPEND AS #4
     PRINT #4, LN$
     CLOSE #4
     GOTO Exit.door

Check.time1:
     WARNING = TIME.OFF - 180
     IF FNTI! > WARNING AND T.IMER = 1 THEN
        WARNING = WARNING + 60
         X.LN$ = "** YOU HAVE" + _
                STR$(INT((TIME.OFF-FNTI!)/60)) + _
                   " MINUTES REMAINING!! **"
         IF L.OCAL <> 1 THEN _
            PRINT #3, CHR$(7)
        GOSUB X.lnprint
        T.IMER = 0
        RETURN
     END IF
     RETURN

Check.time2:
     IF FNTI! > TIME.OFF THEN
        X.LN$ = "TIME LIMIT EXCEEDED!"
        GOSUB X.lnprint
        RETURN Fast.exit
     END IF
     RETURN

FKEY:
  Locate 1,1
  print "Function keys accessible from LOCAL MODE."
  print "  [F1] This list."
  print "  [F2] Drop to DOS"
  print "  [F8] Send user back to WILDCAT"
  print "  [F10] Chat with the user."
  print
  print " -=] Tap a Key when ready. [=- "
64990 q$=inkey$
if q$="" then goto 64990
cls
gosub line25
return
Chatter:                                       '*** F-10 CHAT MODE ***
     SAVETIME = TIME.OFF-FNTI!
     LINE.SAVE$ = LN$
     NORET = 0
     LN$ = ""
     GOSUB Out.put
     GOSUB Out.put
     PRINT "SysOp - Hit ESC to exit chat mode"
     LN$ = "Hi " + _
           FIRST$ + _
           "!  This is " + _
           SYSOP.FIRST$ + _
           " " + _
           SYSOP.LAST$ + _
           ","
     GOSUB Out.put
     GOSUB CAR.TEST
Remote:
     IF LOC(3) = 0 THEN _
        GOTO Local.test
     CHAT$ = INPUT$(1,3)
     IF ASC(CHAT$) = 8 THEN
        PRINT BK.ARW$;
        PRINT #3, BACK.SP$;
     END IF
     IF ASC(CHAT$) = 27 THEN _
        GOTO Local.inp
     PRINT CHAT$;
     PRINT #3,CHAT$;
     IF ASC(CHAT$) = 13 THEN _
        PRINT #3,CHR$(10);
     GOTO Remote

Local.test:
     GOSUB Car.test
     CHAT$ = INKEY$
     IF LEN(CHAT$) = 0 THEN _
        GOTO Remote

Local.inp:
     IF ASC(CHAT$) = 27 THEN _
        GOTO Chat.end
     IF ASC(CHAT$) = 8 THEN
        PRINT BK.ARW$;
        PRINT #3, BACK.SP$;
     END IF
     PRINT CHAT$;
     PRINT #3,CHAT$;
     IF ASC(CHAT$) = 13 THEN _
        PRINT #3,CHR$(10);
     GOTO Remote

Chat.end:
     TIME.OFF = FNTI! + SAVETIME
     WARNING = TIME.OFF-(3*60)
     ENDTIME = FNTI! + 240
     LN$ = ""
     GOSUB Out.put
     ARG$ = ""
     LN$ = "Chat mode terminated"
     GOSUB Out.put
     LN$ = LINE.SAVE$
     GOSUB Out.put
     RETURN

Forceoff:                                      '*** F-9 FORCE OFF ***
     TEMP.STRING$ = STRING$(15,"*")
     LINE.SAVE$ = LN$
     PRINT "SysOp, how many minutes till user is forced off [";_
           INT((TIME.OFF-FNTI!)/60);"]";
     INPUT MIN.F.O$
     IF MIN.F.O$ = "" THEN _
        RETURN
     FORCE.OFF = VAL(MIN.F.O$)
     LN$ = TEMP.STRING$ + _
           " -=> IMPORTANT MESSAGE <=- " + _
           TEMP.STRING$
     GOSUB Out.put
     LN$ = SYSOP.FIRST$ + _
           " " + _
           SYSOP.LAST$ + _
           " needs to use " + _
           BBS.NAME$ + _
           "!  It will be closing down"
     GOSUB Out.put
     LN$ = "in" + _
           STR$(FORCE.OFF) + _
	   " minutes!  Please complete what you are doing within that time"
     GOSUB Out.put
     LN$ = TEMP.STRING$ + _
           ">   END OF MESSAGE  <" + _
           TEMP.STRING$
     GOSUB Out.put
     LN$ = LINE.SAVE$
     GOSUB Out.put
     TIME.OFF = FNTI! + (FORCE.OFF*60)
     WARNING = TIME.OFF - (3*60)
     RETURN

Indoor:
Indoor.end:
      EC = 0
      TIME.OFF = FNTI! + ((VAL(WC$(5))-1)*60)
      NO.MONITOR = 1
      RETURN

Outdoor:
     IF NO.MONITOR = 1 THEN _    ' EXIT IF RUNNING WITHOUT DOOR MONITOR
        RETURN

X.lnprint:
        PRINT X.LN$
     IF L.OCAL<>1 THEN _
        PRINT #3,X.LN$
     RETURN

Read.def:
      IF COM.PORT$ = "COM1" THEN
         MCR = &H3FC
         MSR = &H3FE
         RETURN
      END IF
      MCR = &H2FC
      MSR = &H2FE
      RETURN

Sysop.name:
     SYS.OP = 1
     IF INP(MSR)<128 THEN _
        L.OCAL = 1
     FIRST$ = SYSOP.FIRST$
     LAST$ = SYSOP.LAST$
     CLOSE 3
     RETURN

Read.command:
Read.end:
     RETURN

Snoop:
    GOSUB LINE25
Snoop.end:
     RETURN


Line25:
64005  COLOR 11,1
LOCATE 25,1
print first$+" "; _
  tab(32);door.name$;_
  tab(50);on.at$+" "+"[F1] SysOp options"
  color 7,0
  return

DROPDOS:
  OUT$=CHR$(7)+CHR$(7)
  COLOR 12,0
  LN$=" ** The SysOp has dropped to dos... Please wait...":GOSUB OUT.PUT
  CLS
  PRINT " -=> Attempting to shell to another Command proccessor... <=-"
  PRINT "     Type";:COLOR 4,0:PRINT " EXIT ";:COLOR 12,0:PRINT "to return to the door program."
  PRINT
  PRINT "While in DOS you may wish to note the # of these fine WILDCAT BBS's"
  PRINT
  color 14,0
    PRINT "Acheron!                   Nick At Nite            ";AUTHOR.BBS$
    PRINT "[801] 298-2812             [801] 964-1889          ";AUTHOR.PHONE$
    PRINT "300/1200/2400 Baud         300/1200/2400 Baud      ";AUTHOR.BAUD$
    PRINT "SYSOP: Michael Cleverly    SYSOP: Nick Lemburg     ";AUTHOR.NAME$
REM ** Add your info to the AUTHOR.xxx$ variable's DO NOT remove the first 2! **
   PRINT
  SHELL
  CLS
  gosub line25
  gosub car.test
  OUT$=CHR$(7)+CHR$(7)+CHR$(7)+CHR$(7)
  PRINT "SYSOP! You returned from DOS succesfuly, the door program will now resume."
  LN$="Wake up, "+FIRST$+" the SYSOP came back finally!":GOSUB OUT.PUT
  RETURN
Uplow:
      CONV$ = ARG$
      FOR Z = 1 TO LEN(CONV$)
           IF MID$(CONV$,Z,1) > "@" THEN
	       MID$(CONV$,Z,1) = CHR$(ASC(MID$(CONV$,Z,1)) AND 223)
           END IF
      NEXT
      ARG$ = CONV$
      RETURN

ANSI.COLOR:
return

GRAPHIX:
      ESC$=CHR$(27)                   'Escape character
          GRAPHICS=1
          BLUE$=ESC$+"[1;34;40m"
          GREEN$=ESC$+"[1;32;40m"
          CYAN$=ESC$+"[1;36;40m"
          RED$=ESC$+"[1;31;40m"
          MAGENTA$=ESC$+"[1;35;40m"
          YELLOW$=ESC$+"[1;33;40m"
	  WHITE$=ESC$+"[1;37;40m"
	  PRINT "Graphics mode activated"
          RETURN
 NOANSI:   
	  GRAPHICS=0
	  ESC$=""
	  OUT$="":ARG$=""
          BLUE$=""
          GREEN$=""
          CYAN$=""
          RED$=""
          MAGENTA$=""
          YELLOW$=""
          WHITE$=""
	  Print "Graphix mode de-activated."
	  RETURN

BLUE:
      COLOR 9,0:OUT$=BLUE$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
GREEN:
      COLOR 10,0:OUT$=GREEN$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
CYAN:
      COLOR 11,0:OUT$=CYAN$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
RED:
      COLOR 12,0:OUT$=RED$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
MAGENTA:
      COLOR 13,0:OUT$=MAGENTA$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
YELLOW:
      COLOR 14,0:OUT$=YELLOW$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
WHITE:
      COLOR 15,0:OUT$=WHITE$
      IF L.OCAL=0 THEN PRINT #3,OUT$;
      IF L.OCAL=0 THEN PRINT #3,LN$;
      PRINT LN$;
      OUT$="":LN$=""
      GOSUB CAR.TEST
      RETURN
